import jsonpickle
import yaml


class SwaggerRenderer():
    @classmethod
    def yaml(cls, requests):
        return yaml.dump(cls._format(requests), default_flow_style=False)

    @classmethod
    def json(cls, requests):
        return jsonpickle.encode(cls._format(requests))

    @classmethod
    def _format(cls, requests):
        swagger = {
            "openapi": "3.0.0",
            "info": dict(
                version= "1.0.0",
                title= "Generated by Strut",
                description= ""
                # termsOfService: http://swagger.io/terms/
            )
            # "contact": {
            #     "name": "",
            #     "url": "",
            #     "email": ""
            # }
        }

        paths = {} 

        for request in requests:
            if paths.get(request.url) is None:
                paths[request.url] = {}

            paths[request.url][request.method.lower()] = {
                "description": "",
                "responses": {
                    "200": {
                        "description": "",
                    }
                }
            }

        swagger["paths"] = paths

        return swagger

